package sun.rmi.transport.proxy;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;

class HttpReceiveSocket extends WrappedSocket implements RMISocketInfo {
   private boolean headerSent = false;

   public HttpReceiveSocket(Socket var1, InputStream var2, OutputStream var3) throws IOException {
      super(var1, var2, var3);
      super.in = new HttpInputStream(var2 != null ? var2 : var1.getInputStream());
      super.out = var3 != null ? var3 : var1.getOutputStream();
   }

   public boolean isReusable() {
      return false;
   }

   public InetAddress getInetAddress() {
      return null;
   }

   public int getPort() {
      return super.socket.getPort();
   }

   public OutputStream getOutputStream() throws IOException {
      if (!this.headerSent) {
         DataOutputStream var1 = new DataOutputStream(super.out);
         var1.writeBytes("HTTP/1.0 200 OK\r\n");
         var1.flush();
         this.headerSent = true;
         super.out = new HttpOutputStream(super.out);
      }

      return super.out;
   }

   public synchronized void close() throws IOException {
      this.getOutputStream().close();
      super.socket.close();
   }

   public String toString() {
      return "HttpReceive" + super.socket.toString();
   }
}
